sdr::RealImagPart< Scalar > Class Template Reference
Data handling nodes.

Extracts the real or imaginary part of a complex valued data stream. More...

`#include <utils.hh>`

Inheritance diagram for sdr::RealImagPart< Scalar >:

## Public Member Functions

| RealImagPart (bool select_real, double scale=1.0)
| Constructor. More...
virtual void | config (const Config &src_cfg)
| Configures the node. More...
virtual void | process (const Buffer< std::complex< Scalar > > &buffer, bool allow_overwrite)
| Processes the incomming data. More...
Public Member Functions inherited from sdr::Sink< std::complex< Scalar > >
| Sink ()
| Constructor. More...
virtual | ~Sink ()
| Drestructor. More...
virtual void | handleBuffer (const RawBuffer &buffer, bool allow_overwrite)
| Re-implemented from `SinkBase`. More...
Public Member Functions inherited from sdr::SinkBase
| SinkBase ()
| Constructor. More...
virtual | ~SinkBase ()
| Destructor. More...
Public Member Functions inherited from sdr::Source
| Source ()
| Constructor. More...
virtual | ~Source ()
| Destructor. More...
virtual void | send (const RawBuffer &buffer, bool allow_overwrite=false)
| Sends the given buffer to all connected sinks. More...
void | connect (SinkBase *sink, bool direct=false)
| Connect this source to a sink. More...
void | disconnect (SinkBase *sink)
| Disconnect a sink again. More...
virtual void | setConfig (const Config &config)
| Stores the configuration and propergates it if the configuration has been changed. More...
virtual double | sampleRate () const
| Returns the configured sample rate or `0` otherwise. More...
virtual Config::Type | type () const
| Returns the configured source type or `Config::Type_UNDEFINED` otherwise. More...
template<class T >
void | addEOS (T *instance, void(T::*function)())
| Adds a callback to the end-of-stream signal of the source. More...

## Protected Attributes

Buffer< Scalar > | _buffer
| The output buffer. More...
bool | _select_real
| Real/Imag selection. More...
double | _scale
| The scale. More...
Protected Attributes inherited from sdr::Source
Config | _config
| Holds the source configuration, this can be updated by calling `setConfig`. More...
std::map< SinkBase *, bool > | _sinks
| The connected sinks. More...
std::list< DelegateInterface * > | _eos
| The connected EOS singal handlers. More...

## Additional Inherited Members

Protected Member Functions inherited from sdr::Source
void | signalEOS ()
| Signals the EOS. More...
void | propagateConfig (const Config &config)
| Propagates the given configuration to all connected sinks. More...

## Detailed Description

### template<class Scalar>
class sdr::RealImagPart< Scalar >

Extracts the real or imaginary part of a complex valued data stream.

## Constructor & Destructor Documentation

template<class Scalar >

sdr::RealImagPart< Scalar >::RealImagPart | ( | bool | select_real,
|  | double | scale = `1.0`
| ) |  |

inline

Constructor.

If `select_real` is `true`, the real part is selected, if `select_real` is `false`, the imaginary part is selected.

## Member Function Documentation

template<class Scalar >

virtual void sdr::RealImagPart< Scalar >::config | ( | const Config & | src_cfg | ) |

inlinevirtual

Configures the node.

Implements sdr::SinkBase.

template<class Scalar >

virtual void sdr::RealImagPart< Scalar >::process | ( | const Buffer< std::complex< Scalar > > & | buffer,
|  | bool | allow_overwrite
| ) |  |

inlinevirtual

Processes the incomming data.

Implements sdr::Sink< std::complex< Scalar > >.

## Member Data Documentation

template<class Scalar >

Buffer<Scalar> sdr::RealImagPart< Scalar >::_buffer

protected

The output buffer.

template<class Scalar >

double sdr::RealImagPart< Scalar >::_scale

protected

The scale.

template<class Scalar >

bool sdr::RealImagPart< Scalar >::_select_real

protected

Real/Imag selection.

The documentation for this class was generated from the following file:

- /Users/hannes/Uni/Elektronik/sdr/libsdr/src/utils.hh